<?xml version="1.0" encoding="UTF-8"?>
<refentry xmlns="http://docbook.org/ns/docbook" xmlns:xlink="http://www.w3.org/1999/xlink" xmlns:svg="http://www.w3.org/2000/svg" xmlns:mml="http://www.w3.org/1998/Math/MathML" xmlns:db="http://docbook.org/ns/docbook" xmlns:scilab="http://www.scilab.org" xml:lang="en" xml:id="modbus_writeRegs">
  <refnamediv>
    <refname>modbus_writeRegs</refname>

    <refpurpose>write many bits</refpurpose>
  </refnamediv>

  <refsynopsisdiv>
    <title>Calling Sequence</title>

    <synopsis>
res = modbus_writeRegs(mbc, addr, data)
[res, ierr] = modbus_writeRegs(mbc, addr, data)
    </synopsis>
  </refsynopsisdiv>

 <refsection>
    <title>Arguments</title>
    <variablelist>
      <varlistentry>
        <term>mbc</term>
        <listitem>
          <para>The Modbus connection created with modbus_newTcp or modbus_newRtu.</para>
        </listitem>
      </varlistentry>
      <varlistentry>
        <term>addr</term>
        <listitem>
          <para>The address on device where bits should be write from.</para>
        </listitem>
      </varlistentry>
      <varlistentry>
        <term>data</term>
        <listitem>
          <para>double matrix to write considered as unsigned short.</para>
        </listitem>
      </varlistentry>
      <varlistentry>
        <term>res</term>
        <listitem>
          <para>The number of written bits. -1 if an error occured</para>
        </listitem>
      </varlistentry>
      <varlistentry>
        <term>ierr</term>
        <listitem>
          <para>Erreur number.</para>
        </listitem>
      </varlistentry>
    </variablelist>
  </refsection>

  <refsection>
    <title>Description</title>

    <para>This function writes the status of holding registers from <literal>data</literal> at the address
    <literal>addr</literal> of the remote device</para>

    <para>The function uses the Modbus function code 0x10 (preset multiple registers).</para>

    <para>When called with one output argument, a Scilab error will occur when the writing fails. When called with two output arguments, no Scilab error will occur but <literal>ierr</literal> will contain the internal modbus error number.</para>

  </refsection>

  <refsection>
    <title>Examples</title>

    <programlisting role="example"><![CDATA[
    mbc = modbus_newTcp("127.0.0.1", 502);
    modbus_connect(mbc);
    data = [0; 1; 0; 0; 1; 1; 0; 0; 0; 1; 1; 1];
    res = modbus_writeRegs(mbc, 0, data);
    rData = modbus_readRegs(mbc, 0, res)
    data == rData
    modbus_close(mbc)
    modbus_free(mbc)
]]></programlisting>
  </refsection>



</refentry>
